<template>
  <div class="course-run">
    <client-only>
      <el-main>
        <div v-if="startTime && courseId && courseId != $route.query.id">
          <p>You are already running a course.</p>
          <el-button type="warning" @click="resumeOld"
            >Resume Old Run</el-button
          >
          <el-button type="primary" @click="runNew">Run New</el-button>
        </div>

        <loader :data="loaded" class="grow-column">
          <button class="big button" @click="getLocation">
            Get Location
            <span v-if="location"
              >(Located {{ (now - location.time) | seconds }}s ago
              {{ location.accuracy.toFixed(0) }}m)</span
            >
          </button>
          <el-tabs
            class="grow-column map-meta"
            @tab-click="resizeMap"
            tab-position="bottom"
          >
            <el-tab-pane label="Passport" class="passport">
              <div v-if="error">
                <error-view :error="error" />
                <button class="button" @click="clearError">OK</button>
                <!--            <stateful-button :click="retry">Retry</stateful-button> -->
              </div>
              <span v-else-if="location">
                Located {{ (now - location.time) | seconds }}s ago (accuracy:
                ~{{ location.accuracy }}m).
              </span>
              <span v-else>Locating...</span>
              <div class="elapsed-time" v-if="startTime">
                (Elapsed: {{ (now - startTime) | formatElapsed }})
              </div>
              <div class="punches">
                <div
                  v-for="cp in checkpoints"
                  class="run-checkpoint"
                  :key="cp.id"
                >
                  <span :class="{ status: true, visited: visited(cp) }"
                    >&nbsp;</span
                  >
                  <span class="name">{{ cp.name }}</span>
                  <span v-if="cp.description" class="description">
                    {{ cp.description }}
                  </span>
                  <span v-else class="description absent"
                    >No description provided</span
                  >
                </div>
              </div>
            </el-tab-pane>
            <el-tab-pane label="Map">
              <portal to="map-controls">
                <MglScaleControl position="bottom-right" />
                <MglNavigationControl position="bottom-right" />
              </portal>
              <portal to="map">
                <Checkpoint
                  v-for="cp in checkpoints"
                  :key="cp.key"
                  :value="cp"
                  :visited="visited(cp)"
                />
                <MglConfig
                  :items="checkpoints"
                  @mousemove="mouse"
                  @mousedown="mouse"
                  @mouseup="mouse"
                />
              </portal>
            </el-tab-pane>
            <!-- Debugging area: <el-tab-pane label="Tools">
              <stateful-button :click="refresh">Refresh</stateful-button>
              <stateful-button :click="getLocation"
                >Get Location</stateful-button
              >
              <stateful-button :click="restart">Restart</stateful-button>
              <button class="button" @click="sync">Sync</button>
              <button class="button" @click="sync(true)">
                Sync From Scratch
              </button>
              <button class="button" @click="finish">Finish Run</button>
              {{ $store.state.run.error }}
              <messenger ref="messenger" />
            </el-tab-pane> -->
          </el-tabs>
          <el-dialog
            :visible="startable"
            :modal="false"
            :show-close="false"
            :append-to-body="true"
          >
            <h2>Get ready to go!</h2>
            <p>
              You are at the start line! Tap the start button to start your
              clock!
            </p>
            <button class="big button" @click="start">Start</button>
          </el-dialog>
          <el-dialog
            :visible="
              endable &&
              hasFinish &&
              checkins.length > 1 &&
              !dismissEndableDialog
            "
            :modal="true"
            :append-to-body="true"
            :before-close="closeEndableDialog"
            custom-class="finish-modal"
            title="Finish!"
          >
            <p>You are at the finish line!</p>
            <p v-if="checkpointsLeft">
              You still have {{ checkpointsLeft.length }} checkpoints remaining.
              Do you still wish to end your run?
            </p>
            <careful-button
              class="big button"
              v-if="endable && checkpointsLeft"
              @click="finish"
            >
              End
            </careful-button>
            <el-button class="big button" v-else-if="endable" @click="finish">
              End
            </el-button>
          </el-dialog>
          <el-dialog
            :visible="!!newCheckins"
            :modal="false"
            :show-close="false"
            :append-to-body="true"
            title="Checked in!"
          >
            <span
              v-if="newCheckins"
              v-for="checkin in newCheckins"
              :key="checkin.id"
            >
              You checked in to
              {{ checkpointName(checkin.checkpointId) }}
            </span>
            <span slot="footer" class="dialog-footer">
              <el-button type="primary" @click="finish" v-if="endable">
                End Course
              </el-button>
              <el-button @click="newCheckins = null">OK</el-button>
            </span>
          </el-dialog>
        </loader>
      </el-main>
    </client-only>
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins.scss";

$border: 1px solid white;

.course-run {
  .breadcrumb {
    line-height: 24px;
  }

  .map-container {
    height: 100%;
    width: 100%;
  }

  .big {
    height: $grid * 2;
    width: 100%;
  }

  .punches {
    display: flex;
    flex-direction: column;

    align-items: center;

    max-width: $grid * 30;
    margin: auto;

    border: $border;
  }

  .run-checkpoint {
    display: flex;
    flex-direction: row;

    height: $grid * 2;
    align-items: center;

    width: 100%;

    border-bottom: $border;

    &:last-child {
      border-bottom: none;
    }

    & > * {
      height: 100%;
      display: flex;
      flex-direction: row;
      align-items: center;

      padding-left: $grid * 0.25;

      border-left: $border;
    }

    .status {
      background-color: white;

      padding: 0;

      height: $grid * 1.5;
      width: $grid * 1.5;
      margin: $grid * 0.25;

      border: $border;
      border-radius: $grid;

      &.visited {
        background-color: green;
      }
    }

    .name {
      width: $grid * 4;
    }

    .description {
      flex-grow: 1;

      &.absent {
        font-style: italic;
      }
    }
  }

  .messenger {
    height: $grid * 2;
  }

  &.full-height {
    position: fixed;

    top: 0;
    left: 0;
    right: 0;
    bottom: 0;

    display: flex;
    flex-direction: column;
  }

  .el-main {
    pointer-events: initial;
    position: fixed;
    bottom: 0;
    padding: 0;

    display: flex;
  }

  .el-tabs {
    background-color: $color-background;

    width: 100%;
  }

  .el-tabs__h .el-tab-pane {
    min-height: 100%;
  }

  .passport {
    max-height: calc(100vh - 150px);
    overflow: auto;
    overflow: auto;
  }
}
</style>
<script>
import { pause, geodistance, getter, get, byKey, ascending } from "~/lib/utils";
import NowMixin from "~/mixins/NowMixin";
import Messenger from "~/components/Messenger";
import CarefulButton from "~/components/CarefulButton";
import MglConfig from "~/components/mapping/MglConfig";
import Checkpoint from "~/components/mapping/Checkpoint";

import { mapState, mapGetters } from "vuex";

export default {
  mixins: [NowMixin],
  data() {
    return {
      geoDisabled: false,
      dismissEndableDialog: false,

      loaded: false,

      showMap: false,

      location: null,

      newCheckins: null,
    };
  },
  components: {
    Messenger,
    MglConfig,
    Checkpoint,
    CarefulButton,
  },
  async mounted() {
    if (
      document.location.hostname == "orienteer.co.docker" ||
      this.$route.query.geo_disabled == "true"
    ) {
      this.geoDisabled = true;
    }

    if (this.$store.state.run.end) {
      this.$router.push(`/run/finished`);
    }
    // only load the run if we have the same course ID or aren't currently running a course:
    if (
      !this.$store.state.run.courseId ||
      !this.$store.state.run.start ||
      this.$store.state.run.courseId == this.$route.query.id
    ) {
      this.$store
        .dispatch("run/load", { courseId: this.$route.query.id })
        .then(() => (this.loaded = true));
    }

    if (!this.geoDisabled) this.$geoWatch(this.geoCallback);

    document.addEventListener("visibilitychange", this.visibilityChange);
  },
  beforeDestroy() {
    document.removeEventListener("visibilitychange", this.visibilityChange);
  },
  computed: {
    ...mapState({
      hasFinish: (state) => !!state.run.courseEndCheckpoint,
      courseId: (state) => state.run.courseId,
      error: (state) => state.run.error,
      courseName: (state) => state.run.courseName,
      runId: (state) => state.run.id,
      checkpoints: (state) => state.run.checkpoints,
      events: (state) => state.run.events,
      checkins: (state) => state.run.checkins,
      startTime: (state) => state.run.start && new Date(state.run.start),
    }),
    startable() {
      return this.$store.getters["run/startable"];
    },
    endable() {
      return this.$store.getters["run/endable"];
    },
    checkpointsLeft() {
      const left = this.$store.state.run.checkpoints.filter(
        (checkpoint) =>
          !this.$store.state.run.checkins.find(
            (checkin) => checkin.checkpointId == checkpoint.id
          )
      );
      if (left.length == 0) return null;
      return left;
    },
  },
  filters: {
    seconds(value) {
      return Math.round(value / 1000);
    },
  },
  watch: {
    checkins: {
      deep: true,
      async handler(n, o) {
        const newCheckins = n.filter((item) => !o.includes(item));

        if (newCheckins.length > 0) {
          this.newCheckins = newCheckins;

          await pause(10000);
          if (this.newCheckins == newCheckins);
          this.newCheckins = null;
        }
      },
    },
  },
  methods: {
    async closeEndableDialog(id) {
      this.dismissEndableDialog = true;
      await pause(5000);
      this.dismissEndableDialog = false;
    },
    checkpointName(id) {
      const c = this.checkpoints.find((c) => c.id == id);
      return (c && c.name) || "Unnamed checkpoint";
    },
    mouse(e) {
      if (!this.geoDisabled) return;
      e.preventDefault();

      if (e.originalEvent.buttons) {
        this.geoCallback(null, { type: "fake", accuracy: -1, ...e.lngLat });
      }
    },

    resizeMap() {
      if (this.$refs.map && this.$refs.map.map) {
        this.$nextTick(() => this.$refs.map.map.resize());
      }
    },
    visibilityChange() {
      this.$store.commit("run/event", {
        type: "visibilitychange",
        state: document.visibilityState,
      });

      if (document.visibilityState == "visible") {
        setTimeout(this.$geoPosition, 2000);
        this.$geoPosition();
      }
    },
    clearError() {
      this.$store.commit("run/error", null);
    },
    resumeOld() {
      this.$router.replace(`/run/course?id=${this.courseId}`);
    },
    async runNew() {
      this.loaded = false;

      await this.$store.dispatch("run/sync");
      await this.$store.dispatch("run/load", {
        courseId: this.$route.query.id,
      });

      this.loaded = true;
      this.resizeMap();
      // window.document.location.refresh();
    },
    start() {
      this.$store.dispatch("run/start");
    },
    async finish() {
      await this.$store.dispatch("run/finish");
      this.$router.push(`/run/finished`);
    },
    sync(force = false) {
      this.$store.commit("run/event", { type: "sync" });
      this.$store.dispatch("run/sync", { force });
    },
    async getLocation() {
      await this.$geoPosition();
    },
    async refresh() {
      this.loaded = false;
      await this.$store.dispatch("run/load", {
        courseId: this.$route.query.id,
      });
      this.loaded = true;
    },
    async geoCallback(error, location) {
      if (error) {
        this.$store.commit("error", error);
      }

      console.log("CALLBACK: ", location);

      this.location = location;

      if (location) {
        await this.$store.dispatch("run/location", {
          type: "watch",
          ...location,
        });

        if (!this.checkpointsLeft && this.endable) {
          this.dismissEndableDialog = true;
          this.finish();
        }
      }
    },
    restart() {
      this.$store.commit("run/event", { type: "restart" });
      this.$geoStopWatches();
      this.$geoWatch(this.geoCallback);
      this.$geoPosition();
    },
    visited(cp) {
      return (
        this.checkins && !!this.checkins.find((v) => v.checkpointId == cp.id)
      );
    },
    message(message) {
      if (this.$refs.messenger) {
        this.$refs.messenger.message(message);
      }
    },
  },
};
</script>
<style lang="scss">
@import "~assets/mixins";

.course-run {
  .el-tabs__nav {
    float: initial;
    width: 100vw;

    display: flex;
    flex-direction: row;

    .el-tabs__item {
      flex-grow: 1;
      flex-shrink: 1;
      flex-basis: 0;

      text-align: center;
    }
  }
}

.route__run--course {
  .mapboxgl-ctrl-bottom-right,
  .mapboxgl-ctrl-bottom-left {
    padding-bottom: $grid * 4;
  }
}
</style>
